import EventEmitter from "events";

export default class EventBus extends EventEmitter {
  private static _instance: EventBus | null = null;

  public static getInstance() {
    if (!EventBus._instance) {
      EventBus._instance = new EventBus();
    }
    return EventBus._instance;
  }

  private constructor() {
    super();
    this.setMaxListeners(64);
  }
}

export namespace EventNamesDefine {
  export const UnKnow = "onUnKnow";
  export const UnSelectAllWindows = "onUnSelectAllWindows";
  export const UnFocusAllWindows = "onUnFocusAllWindows";
  export const WindowResize = "onWindowResize";
  export const ResponseMessage = "onResponseData";
  export const NotifyMessage = "onNotifyMessage";
  export const WebSocketClose = "onWebSocketClose";
  export const WebSocketError = "onWebSocketError";
  export const WebSocketConnected = "onWebSocketConnected";
  export const CurrentConnectDisconnect = "onCurrentConnectDisconnect";
  export const CurrentConnectConnected = "onCurrentConnectConnected";
}
