import BaseEntity from "./BaseEntity";
import { SignalSourceEntity } from "./SignalSourceEntity";
import { Protocol } from "./WSProtocol";

export class WindowStates {
  playing = false;
  focus = false;
  muted = false;

  constructor(playing?: boolean, focus?: boolean, muted?: boolean) {
    this.playing = playing ?? false;
    this.focus = focus ?? false;
    this.muted = muted ?? false;
  }
}

export class MultimediaWindowEntity extends BaseEntity {
  x: number = 0;
  y: number = 0;
  width: number = 0;
  height: number = 0;
  signal_source_table_uuid: string = "";

  window_state = new WindowStates();
}

export class WindowOpenNotifyEntity extends MultimediaWindowEntity {
  public static get FLAG_REQUEST() {
    return 0;
  }
  public static get FLAG_RESPONSE() {
    return 1;
  }
  public static get FLAG_NOTIFY() {
    return 2;
  }

  /** 是否出现异常,如果是异常,则为 ExceptionEntity */
  has_exception = false;
  /** 0: 请求  1: 响应 */
  flag = WindowOpenNotifyEntity.FLAG_REQUEST;
  /** rpc 消息 ID，默认 0 */
  rpc_id = 0;
  /** 命令 */
  command = Protocol.Commands.kUnKnowCommand;

  window_id: number = 0;
}
