import { RouteRecordRaw } from 'vue-router';

import PermissionLevel from 'src/entities/PermissionLevel';

const routes: RouteRecordRaw[] = [
  {
    path: '/login',
    component: () => import('pages/Login.vue'),
  },
  {
    path: '/',
    meta: {
      permission_level: PermissionLevel.User,
    },
    component: () => import('layouts/MainLayout.vue'),
    children: [
      {
        path: '',
        component: () => import('pages/Index.vue'),
        meta: {
          permission_level: PermissionLevel.User,
        },
      },
    ],
  },

  // Always leave this as last one,
  // but you can also remove it
  {
    path: '/:catchAll(.*)*',
    component: () => import('pages/Error404.vue'),
  },
];

export default routes;
